﻿using System;
using System.Data.SqlClient;
using System.Data;

namespace RGF_DAL
{
    public class Connection_Class
    {
        /// <summary>
        /// کانکشن استرینگ
        /// در ستینگ پروژه
        /// </summary>
        string ConnectionString
        {
            get
            {
                return Properties.Settings.Default.Con;
            }
        }
        /// <summary>
        /// متد جهت عملیاتهای درج ، حذف و ویرایش
        /// </summary>
        /// <param name="C_Type"></param>
        /// <param name="C_Text"></param>
        /// <param name="C_Parameters"></param>
        /// <returns></returns>
        public int ExecuteNoneQuery(CommandType C_Type, string C_Text, params SqlParameter[] C_Parameters)
        {
            SqlConnection Con = new SqlConnection(ConnectionString);
            SqlCommand Com = new SqlCommand();
            Com.Connection = Con;
            Com.CommandType = C_Type;
            Com.CommandText = C_Text;
            Com.Parameters.AddRange(C_Parameters);
            Con.Open();
            int R_Value = Com.ExecuteNonQuery();
            Con.Close();
            return R_Value;
        }
        /// <summary>
        /// متد دیتااسکالر
        /// </summary>
        /// <param name="C_Type"></param>
        /// <param name="C_Text"></param>
        /// <param name="C_Parameters"></param>
        /// <returns></returns>
        public object ExecuteScaler(CommandType C_Type, string C_Text, params SqlParameter[] C_Parameters)
        {
            SqlConnection Con = new SqlConnection(ConnectionString);
            SqlCommand Com = new SqlCommand();
            Com.Connection = Con;
            Com.CommandType = C_Type;
            Com.CommandText = C_Text;
            Com.Parameters.AddRange(C_Parameters);
            Con.Open();
            object R_Value = Com.ExecuteNonQuery();
            Con.Close();
            return R_Value;
        }
        /// <summary>
        /// متد دیتاریدر
        /// </summary>
        /// <param name="C_Type"></param>
        /// <param name="C_Text"></param>
        /// <param name="C_Parameters"></param>
        /// <returns></returns>
        public SqlDataReader ExecuteReader(CommandType C_Type, string C_Text, params SqlParameter[] C_Parameters)
        {
            SqlConnection Con = new SqlConnection(ConnectionString);
            SqlCommand Com = new SqlCommand();
            Com.Connection = Con;
            Com.CommandType = C_Type;
            Com.CommandText = C_Text;
            Com.Parameters.AddRange(C_Parameters);
            bool Close_Connection = false;
            try
            {
                if (Con.State != ConnectionState.Open)
                {
                    Close_Connection = true;
                    Con.Open();
                }
                else
                {
                    Close_Connection = false;
                }
                SqlDataReader DR;
                DR = Com.ExecuteReader(CommandBehavior.CloseConnection);
                return DR;
            }
            catch
            {
                if (Close_Connection)
                    Con.Close();
                throw;
            }
        }
        /// <summary>
        /// متد دیتاتیبل
        /// </summary>
        /// <param name="C_Type"></param>
        /// <param name="C_Text"></param>
        /// <param name="C_Parameters"></param>
        /// <returns></returns>
        public DataTable ExecuteDataTable(CommandType C_Type, string C_Text, params SqlParameter[] C_Parameters)
        {
            SqlConnection Con = new SqlConnection(ConnectionString);
            SqlCommand Com = new SqlCommand();
            Com.Connection = Con;
            Com.CommandType = C_Type;
            Com.CommandText = C_Text;
            Com.Parameters.AddRange(C_Parameters);
            DataTable DS = new DataTable();
            SqlDataAdapter DA = new SqlDataAdapter(Com);
            Con.Open();
            DA.Fill(DS);
            Con.Close();
            return DS;
        }
    }
}
