﻿using System;
using System.Data.SqlClient;
using System.Data;

namespace RGF_DAL
{
    public class Invoice_Dal : Connection_Class
    {
        /// <summary>
        /// چارامترهای درج در جدول فاکتور
        /// </summary>
        /// <param name="Person_Id"></param>
        /// <param name="Invoice_Type"></param>
        /// <param name="Date"></param>
        /// <param name="Type"></param>
        /// <returns></returns>
        public int Invoice(int Person_Id, string Invoice_Type, DateTime Date, bool Type)
        {
            return ExecuteNoneQuery(CommandType.Text, "Insert Into Tbl_Invoice (Person_Id, Invoice_Type, Date, Type) Values (@P, @I, @D, @T)", new SqlParameter[]
            {
                new SqlParameter("@P", Person_Id),
                new SqlParameter("@I", Invoice_Type),
                new SqlParameter("@D", Date),
                new SqlParameter("@T", Type),
            });
        }
        /// <summary>
        /// بدست آوردن آخرین آیدی جدول فاکتور
        /// </summary>
        int Last_Invoice_Id;
        public int Last_Id()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "SELECT Max(Id) FROM Tbl_Invoice");
                if (DR.Read())
                {
                    Last_Invoice_Id = Int32.Parse(DR[0].ToString());
                }
                return Last_Invoice_Id;
            }
            catch
            {
                return 0;
            }
        }
        /// <summary>
        /// دیتاتیبل جهت نمایش اطلاعات شرکت در هدر فاکتور
        /// </summary>
        /// <returns></returns>
        public DataTable Select_Company()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "Select Name, Phone_No, City, Address From Tbl_Company");
        }

        int Invoice_No;
        public int Invoice_Num()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Count(*) From Tbl_Invoice");
                if (DR.Read())
                {
                    Invoice_No = Int32.Parse(DR[0].ToString());
                }
                return Invoice_No;
            }
            catch
            {
                return 0;
            }
        }
    }
}