﻿using System;
using System.Data.SqlClient;
using System.Globalization;
using System.Data;

namespace RGF_DAL
{
    public class Usable_Dal : Connection_Class
    {
        /// <summary>
        /// درج کاربر
        /// </summary>
        /// <param name="Name"></param>
        /// <param name="User_Name"></param>
        /// <param name="Pass"></param>
        /// <param name="User_Type"></param>
        /// <param name="User_Access"></param>
        /// <param name="Sec_Question"></param>
        /// <param name="Sec_Answer"></param>
        /// <returns></returns>
        public int User(string Name, string User_Name, string Pass, string User_Type, int User_Access, string Sec_Question, string Sec_Answer)
        {
            return ExecuteNoneQuery(CommandType.Text, "Insert Into Tbl_User (Name, User_Name, Pass, User_Type, User_Access, Sec_Question, Sec_Answer) Values (@N, @U, @P, @UT, @UA, @SQ, @SA)", new SqlParameter[]
            {
                new SqlParameter("@N", Name),
                new SqlParameter("@U", User_Name),
                new SqlParameter("@P", Pass),
                new SqlParameter("@UT", User_Type),
                new SqlParameter("@UA", User_Access),
                new SqlParameter("@SQ", Sec_Question),
                new SqlParameter("@SA", Sec_Answer),
            });
        }

        /// <summary>
        /// فهرست کاربران
        /// </summary>
        /// <returns></returns>
        public DataTable User_Info()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "Select * From Tbl_User");
        }

        /// <summary>
        /// حذف کاربر
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public int Delete_User(int Id)
        {
            return ExecuteNoneQuery(CommandType.Text, "Delete From Tbl_User Where Id = @I", new SqlParameter[]
            {
                new SqlParameter("@I", Id),
            });
        }

        /// <summary>
        /// دستورات پنجره ورود
        /// </summary>
        /// <param name="User_Name"></param>
        /// <param name="Pass"></param>
        /// <returns></returns>
        public DataTable Select_User(string User_Name, string Pass)
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "Select Name, User_Name, Pass, User_Type, User_Access From Tbl_User Where (User_Name = @U And Pass = @P)", new SqlParameter[]
            {
                 new SqlParameter("@U", User_Name),
                 new SqlParameter("@P", Pass),
            });
        }

        /// <summary>
        /// دستورات یاد آوری کلمه عبور
        /// </summary>
        /// <param name="User_Name"></param>
        /// <param name="Pass"></param>
        /// <param name="Sec_Question"></param>
        /// <param name="Sec_Answer"></param>
        /// <returns></returns>
        public DataTable Remember_User(string User_Name, string Sec_Question, string Sec_Answer)
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "Select User_Name, Pass, Sec_Question, Sec_Answer From Tbl_User Where (User_Name = @U AND Sec_Question = @Q AND Sec_Answer = @A)", new SqlParameter[]
            {
                 new SqlParameter("@U", User_Name),
                 new SqlParameter("@Q", Sec_Question),
                 new SqlParameter("@A", Sec_Answer),
            });
        }

        ///////////////////////////////////////////////////////////////// مقادیر آمار و اطلاعات عددی

        /// <summary>
        /// جمع کل فروش
        /// </summary>
        double Total_Sell_Price;
        public double Total_Sell()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice Where Type =" + 1);
                if (DR.Read())
                {
                    Total_Sell_Price = Double.Parse(DR[0].ToString());
                }
                return Total_Sell_Price;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// جمع کل خرید
        /// </summary>
        double Total_Buy_Price;
        public double Total_Buy()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice Where Type =" + 0);
                if (DR.Read())
                {
                    Total_Buy_Price = Double.Parse(DR[0].ToString());
                }
                return Total_Buy_Price;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// جمع کل هزینه
        /// </summary>
        double Total_Cost_Price;
        public double Total_Cost()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Price) From Tbl_Cost");
                if (DR.Read())
                {
                    Total_Cost_Price = Double.Parse(DR[0].ToString());
                }
                return Total_Cost_Price;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// پرفروش ترین کالا
        /// </summary>
        /// <returns></returns>
        public DataTable UP_Commodity()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT TOP(1) Expr1, SUM(Quantity) AS Total_Quantity FROM View_Invoice WHERE Type = 1 GROUP BY Expr1 ORDER BY SUM(Quantity) DESC");
        }

        /// <summary>
        /// کم فروشترین کالا
        /// </summary>
        /// <returns></returns>
        public DataTable Down_Commodity()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT TOP(1) Expr1, SUM(Quantity) AS Total_Quantity FROM View_Invoice WHERE Type = 1 GROUP BY Expr1 ORDER BY SUM(Quantity) ASC");
        }

        /// <summary>
        /// جدول فاکتور و سنگین ترین فاکتور
        /// </summary>
        /// <returns></returns>
        public DataTable Best_Invoice()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "select * from (select Invoice_Id, Sum(Quantity * Unit_Price) AS Total_Sum, count(Id) AS Order_Count from View_Invoice group by Invoice_Id) Q order by Q.Total_Sum DESC");
        }

        /// <summary>
        /// فروش ماه جاری
        /// </summary>
        double Mouth_Sell;
        public double Mouthsell()
        {
            DateTime today = DateTime.Now;
            PersianCalendar persianCalendar = new PersianCalendar();
            int yearPersian = persianCalendar.GetYear(today);
            int monthPersian = persianCalendar.GetMonth(today);
            DateTime firstDayOfMonth = persianCalendar.ToDateTime(yearPersian, monthPersian, 1, 0, 0, 0, 0);
            int daysInMonth = persianCalendar.GetDaysInMonth(yearPersian, monthPersian);
            DateTime lastDayOfMonth = firstDayOfMonth.AddDays(daysInMonth - 1);
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice WHERE Type =" + 1 + "AND Date Between @F AND @L", new SqlParameter[]
                {
                    new SqlParameter("@F", firstDayOfMonth),
                    new SqlParameter("@L", lastDayOfMonth),
                });
                if (DR.Read())
                {
                    Mouth_Sell = Double.Parse(DR[0].ToString());
                }
                return Mouth_Sell;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// خرید ماه
        /// </summary>
        double Mouth_Buy;
        public double Mouthbuy()
        {
            DateTime today = DateTime.Now;
            PersianCalendar persianCalendar = new PersianCalendar();
            int yearPersian = persianCalendar.GetYear(today);
            int monthPersian = persianCalendar.GetMonth(today);
            DateTime firstDayOfMonth = persianCalendar.ToDateTime(yearPersian, monthPersian, 1, 0, 0, 0, 0);
            int daysInMonth = persianCalendar.GetDaysInMonth(yearPersian, monthPersian);
            DateTime lastDayOfMonth = firstDayOfMonth.AddDays(daysInMonth - 1);
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice WHERE Type =" + 0 + "AND Date Between @F AND @L", new SqlParameter[]
                {
                    new SqlParameter("@F", firstDayOfMonth),
                    new SqlParameter("@L", lastDayOfMonth),
                });
                if (DR.Read())
                {
                    Mouth_Buy = Double.Parse(DR[0].ToString());
                }
                return Mouth_Buy;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// هزینه ماه
        /// </summary>
        double Mouth_Cost;
        public double Mounthcost()
        {
            DateTime today = DateTime.Now;
            PersianCalendar persianCalendar = new PersianCalendar();
            int yearPersian = persianCalendar.GetYear(today);
            int monthPersian = persianCalendar.GetMonth(today);
            DateTime firstDayOfMonth = persianCalendar.ToDateTime(yearPersian, monthPersian, 1, 0, 0, 0, 0);
            int daysInMonth = persianCalendar.GetDaysInMonth(yearPersian, monthPersian);
            DateTime lastDayOfMonth = firstDayOfMonth.AddDays(daysInMonth - 1);
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Price) From Tbl_Cost Where Dat Between @F AND @L", new SqlParameter[]
                {
                    new SqlParameter("@F", firstDayOfMonth),
                    new SqlParameter("@L", lastDayOfMonth),
                });
                if (DR.Read())
                {
                    Mouth_Cost = Double.Parse(DR[0].ToString());
                }
                return Mouth_Cost;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// مبلغ فروش روزانه
        /// </summary>
        double Day_Sell;
        public double Daysell()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice WHERE Type =" + 1 + "AND Date = @D", new SqlParameter[]
                {
                    new SqlParameter("@D", DateTime.Today),
                });
                if (DR.Read())
                {
                    Day_Sell = Double.Parse(DR[0].ToString());
                }
                return Day_Sell;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// مبلغ خرید روزانه
        /// </summary>
        double Day_Buy;
        public double Daybuy()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Quantity * Unit_Price) AS Total_Buy From View_Invoice WHERE Type =" + 0 + "AND Date = @D", new SqlParameter[]
                {
                    new SqlParameter("@D", DateTime.Today),
                });
                if (DR.Read())
                {
                    Day_Buy = Double.Parse(DR[0].ToString());
                }
                return Day_Buy;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// مبلغ هزینه روزانه
        /// </summary>
        double Day_Cost;
        public double Daycost()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Sum(Price) From Tbl_Cost Where Dat = @D", new SqlParameter[]
                {
                    new SqlParameter("@D", DateTime.Today),
                });
                if (DR.Read())
                {
                    Day_Cost = Double.Parse(DR[0].ToString());
                }
                return Day_Cost;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// فهرست فاکتور
        /// </summary>
        /// <returns></returns>
        public DataTable Invoice_List()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT Id, (Name + ' ' + Last_Name) AS Full_Name, Invoice_Type, Date From View_Invoice_List");
        }

        /// <summary>
        /// فهرست سفارشات هر فاکتور
        /// بر حسب شماره فاکتور
        /// </summary>
        /// <param name="Invoice_Id"></param>
        /// <returns></returns>
        public DataTable Order_List(int Invoice_Id)
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT Invoice_Id, Name, Quantity, Unit_Price, (Quantity * Unit_Price) AS Sum From View_Order_List Where Invoice_Id = @I", new SqlParameter[]
            {
                new SqlParameter("@I", Invoice_Id),
            });
        }

        /// <summary>
        /// بدست آوردن مبلغ یک فاکتور
        /// بر حسب شماره فاکتور
        /// </summary>
        /// <param name="Invoice_Id"></param>
        /// <returns></returns>
        public DataTable Invoice_Payable(int Invoice_Id)
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT Sum(Quantity * Unit_Price) AS Invoice_Payable From View_Order_List Where Invoice_Id = @I", new SqlParameter[]
            {
                new SqlParameter("@I", Invoice_Id),
            });
        }

        /// <summary>
        /// فهرست اسناد
        /// </summary>
        /// <returns></returns>
        public DataTable Document_Info()
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "Select Id, Main_Document_No, Type, (Name + ' ' + Last_Name) AS Full_Name, Date, Description From View_Document_List");
        }

        /// <summary>
        /// فهرست اقلام سند بر حسب شماره سند
        /// </summary>
        /// <param name="Document_Id"></param>
        /// <returns></returns>
        public DataTable Doc_Commodity(int Document_Id)
        {
            return ExecuteDataTable(System.Data.CommandType.Text, "SELECT Document_Id, Name, Quantity, Unit From View_Doc_Commo_List Where Document_Id = @I", new SqlParameter[]
            {
                new SqlParameter("@I", Document_Id),
            });
        }

        /// <summary>
        /// بدست آوردن تعداد
        /// رسید کالا
        /// </summary>
        int Incoming_No;
        public int Doc_Incoming()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Count(*) From Tbl_Document Where Type_Bool =" + 1);
                if (DR.Read())
                {
                    Incoming_No = int.Parse(DR[0].ToString());
                }
                return Incoming_No;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// بدست آوردن تعداد
        /// حواله کالا
        /// </summary>
        int Outcoming_No;
        public int Doc_Outcoming()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select Count(*) From Tbl_Document Where Type_Bool =" + 0);
                if (DR.Read())
                {
                    Outcoming_No = int.Parse(DR[0].ToString());
                }
                return Outcoming_No;
            }
            catch
            {
                return 0;
            }
        }

        /////////////////////////////////////////// بکاپ گیری از دیتابیس
        /// <summary>
        /// گرفتن حجم دیتابیس
        /// </summary>
        /// <returns></returns>
        public DataTable DB_Space()
        {
            DataTable DT = new DataTable();
            try
            {
               DT = ExecuteDataTable(System.Data.CommandType.Text, "exec sp_spaceused");
            }
            catch { }
            return DT;
        }

        /// <summary>
        /// درج مقادیر بکاپ گیری
        /// </summary>
        /// <param name="User_Info"></param>
        /// <param name="Space_Used"></param>
        /// <param name="Dat"></param>
        /// <returns></returns>
        public int Insert_Backup(string User_Info, string Space_Used, DateTime Dat)
        {
            return ExecuteNoneQuery(CommandType.Text, "Insert Into Tbl_Backup (User_Info, Space_Used, Dat) Values (@U, @S, @D)", new SqlParameter[]
            {
                new SqlParameter("@U", User_Info),
                new SqlParameter("@S", Space_Used),
                new SqlParameter("@D", Dat),
            });
        }

        /// <summary>
        /// جدول بکاپ گیری
        /// </summary>
        /// <returns></returns>
        public DataTable Show_Backup()
        {
            return ExecuteDataTable(CommandType.Text, "Select * From Tbl_Backup");
        }

        /// <summary>
        /// تنخواه و هزینه
        /// </summary>
        /// <returns></returns>
        public DataTable Show_Cost()
        {
            return ExecuteDataTable(CommandType.Text, "Select Id, Cost, Price, (Name + ' ' + Last_Name) AS Full_Name, Dat From View_Cost");
        }

        /// <summary>
        /// فهرست سند ورود و خروج کالا
        /// </summary>
        /// <returns></returns>
        public DataTable IO_List()
        {
            return ExecuteDataTable(CommandType.Text, "Select * From View_Inventory ORDER BY Date");
        }

        /// <summary>
        /// فهرست موجودی کالا
        /// </summary>
        /// <returns></returns>
        public DataTable Inventory_Commodity()
        {
            return ExecuteDataTable(CommandType.StoredProcedure, "SP_Inventory");
        }

        /// <summary>
        /// بدست آوردن حجم
        /// ورودی کالا
        /// </summary>
        double Inventory_In;
        public double In_Inventory()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select SUM(Quantity) From View_Inventory Where Type_Bool =" + 1);
                if (DR.Read())
                {
                    Inventory_In = int.Parse(DR[0].ToString());
                }
                return Inventory_In;
            }
            catch
            {
                return 0;
            }
        }

        /// <summary>
        /// بدست آوردم حجم
        /// خروجی کالا
        /// </summary>
        double Inventory_Out;
        public double Out_Inventory()
        {
            try
            {
                SqlDataReader DR = ExecuteReader(System.Data.CommandType.Text, "Select SUM(Quantity) From View_Inventory Where Type_Bool =" + 0);
                if (DR.Read())
                {
                    Inventory_Out = int.Parse(DR[0].ToString());
                }
                return Inventory_Out;
            }
            catch
            {
                return 0;
            }
        }
    }
}
