﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Commodity : Form
    {
        private int searchIndex = -1;

        public Frm_Commodity()
        {
            InitializeComponent();
            Dgv_Commo.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
        }

        Txt_Clean tc = new Txt_Clean();

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        /// <summary>
        /// چک کردن فعال بودن برنامه
        /// </summary>
        private void Expire() // فعالسازی برنامه
        {
            if (Properties.Settings.Default.Reg_Check == true)
            {
                new Serial().Trial_Expired();
                Application.ExitThread();
            }
        }

        #region Insert_Category
        /// <summary>
        /// متود ذخیره در جدول دسته بندی کالا
        /// </summary>
        private void Insert_Category()
        {
            try
            {
                Category_Bll.Insert_Category(Convert.ToInt32(Cmb_Ware.SelectedValue), Txt_Cat.Text.Trim(), Txt_Cat_Desc.Text.Trim());
                Ok.ShowBox(" دسته با نام " + Txt_Cat.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Name_Cat"))
                {
                    Warning.ShowBox("نام دسته بندی تکراری و در فهرست موجود است .", "نام دسته !");
                    Txt_Cat.Focus();
                }
            }
        }
        /// <summary>
        /// کلید ذخیره دسته بندی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Cat_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Ware.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "شماره انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Ware, 5000);
                TT.Show("شماره انبار را وارد نمایید", Cmb_Ware);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Cat.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام دسته !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Cat, 5000);
                TT.Show("نام دسته کالا را وارد نمایید", Txt_Cat);
            }
            else if (Cmb_Ware.Text != "" && Txt_Cat.Text != "")
            {
                try
                {
                    Insert_Category();
                    Cmb_Ware.ResetText();
                    Frm_Commodity_Load(null, null);
                }
                catch
                {
                    Error.ShowBox(@"مشخصات دسته ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        /// <summary>
        /// بایند کمبوباکس انتخاب انبار
        /// </summary>
        private void Combo()
        {
            Cmb_Ware.DataSource = new Warehouse_Bll().Ware_No_Combo();
            Cmb_Ware.DisplayMember = "Name";
            Cmb_Ware.ValueMember = "Id";
        }
        #endregion

        private void Frm_Commodity_Load(object sender, EventArgs e)
        {
            Expire();
            Combo();
            Combo_2();
            Cmb_Ware.ResetText();
            Cmb_Cat_No.ResetText();
            Gridview();
        }

        #region Insert_Group
        /// <summary>
        /// متود درج در جدول گروه کالا
        /// </summary>
        private void Insert_Group()
        {
            try
            {
                Group_Bll.Insert_Group(Convert.ToInt32(Cmb_Cat_No.SelectedValue), Txt_Group.Text.Trim(), Txt_GP_Desc.Text.Trim());
                Ok.ShowBox(" گروه کالا با نام " + Txt_Group.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Name_Group"))
                {
                    Warning.ShowBox("نام گروه کالا تکراری و در فهرست موجود است .", "نام گروه !");
                    Txt_Group.Focus();
                }
            }
        }
        /// <summary>
        /// بایند کمبوباکس انتخاب دسته بندی
        /// </summary>
        private void Combo_2()
        {
            Cmb_Cat_No.DataSource = new Category_Bll().Cat_No_Combo();
            Cmb_Cat_No.DisplayMember = "Name";
            Cmb_Cat_No.ValueMember = "Id";
        }
        /// <summary>
        /// کلید درج گروه کالا
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Group_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Cat_No.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "شماره دسته !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Cat_No, 5000);
                TT.Show("شماره دسته را وارد نمایید", Cmb_Cat_No);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Group.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام گروه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Group, 5000);
                TT.Show("نام گروه کالا را وارد نمایید", Txt_Group);
            }
            else if (Cmb_Cat_No.Text != "" && Txt_Group.Text != "")
            {
                try
                {
                    Insert_Group();
                    Cmb_Cat_No.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات گروه ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        /// <summary>
        /// پر کردن گریدویو با اطلاعات جدول کالا
        /// </summary>
        public void Gridview()
        {
            Dgv_Commo.DataSource = Commodity_Bll.Full_Show();
        }

        private void Btn_New_Click(object sender, EventArgs e)
        {
            new Frm_New_Commodity().ShowDialog();
        }
        /// <summary>
        /// اضافه کردن نام تصویر ذخیره شده در بانک به دایرکتوری
        /// و نمایش تصویر همنام از پوشه تصاویر در پیکچرباکس
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Dgv_Commo_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            try
            {
                Lbl_Info_Name.Text = "نام کالا : " + Dgv_Commo.CurrentRow.Cells[3].Value.ToString();
                Pic_Logo.Image = System.Drawing.Image.FromFile("Data/Image/" + Dgv_Commo.CurrentRow.Cells[5].Value.ToString());
                Lbl_Info_Code.Text = "توضیحات : " + Dgv_Commo.CurrentRow.Cells[4].Value.ToString();
            }
            catch { }
        }

        private void Btn_Search_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < Dgv_Commo.Rows.Count; i++)
                {
                    searchIndex = (searchIndex + 1) % Dgv_Commo.Rows.Count;
                    DataGridViewRow row = Dgv_Commo.Rows[searchIndex];
                    if (row.Cells["Commodity_Name"].Value == null)
                    {
                        continue;
                    }
                    if (row.Cells["Commodity_Name"].Value.ToString().Trim().StartsWith(Txt_Search.Text) || row.Cells["Commodity_Name"].Value.ToString().Trim().ToLower().Contains(Txt_Search.Text))
                    {
                        Dgv_Commo.CurrentCell = row.Cells["Commodity_Name"];
                        Dgv_Commo.FirstDisplayedScrollingRowIndex = Dgv_Commo.Rows[row.Index].Index;
                        row = Dgv_Commo.Rows[i];
                        return;
                    }
                }
            }
            catch { }
        }
    }
}
