﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using RGF_BLL;
using RGF_UI;
using System.Windows.Forms.DataVisualization.Charting;


namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Commodity_List : Form
    {
        public Frm_Commodity_List()
        {
            InitializeComponent();
            Dgv_List.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Dgv_Inventory.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
        }

        Chart Total_Chart;
        double In_Coming;
        double Out_Going;
        double Full_Inventory;

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Show_Data()
        {
            Dgv_List.DataSource = new Usable_Bll().IO_List();
            Dgv_Inventory.DataSource = new Usable_Bll().Inventory_Commodity();
            In_Coming = new Usable_Bll().In_Inventory();
            Out_Going = new Usable_Bll().Out_Inventory();
            for (int i = 0; i < Dgv_Inventory.Rows.Count; i++)
            {
                Full_Inventory += Convert.ToDouble(Dgv_Inventory.Rows[i].Cells[2].Value);
            }
        }

        private void Chart_Info()
        {
            try
            {
            Total_Chart = new Chart();
            ChartArea Area = new ChartArea();
            Total_Chart.ChartAreas.Add(Area);
            Series S_1 = new Series();
            Total_Chart.Series.Add(S_1);
            double[] yval = { In_Coming, Out_Going, Full_Inventory };
            string[] xval = { "حجم ورودی کالا", "حجم خروجی کالا", "حجم موجودی کالا" };
            Total_Chart.Series[0].Points.DataBindXY(xval, yval);
            Total_Chart.Series[0].ChartType = SeriesChartType.Doughnut;
            Total_Chart.Location = new System.Drawing.Point(60, 0);
            Total_Chart.Size = new System.Drawing.Size(320, 300);
            Total_Chart.Legends.Add("num");
            this.Controls["Pln_Chart"].Controls.Clear();
            this.Controls["Pln_Chart"].Controls.Add(Total_Chart);
            Total_Chart.BackColor = Color.White;
            Total_Chart.ChartAreas[0].BackColor = Color.Transparent;
            Total_Chart.Series[0].Points[0].Color = Color.FromArgb(137, 196, 244);
            Total_Chart.Series[0].Points[1].Color = Color.FromArgb(209, 222, 192);
            Total_Chart.Series[0].Points[2].Color = Color.FromArgb(253, 227, 227);
            Total_Chart.Legends[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
            Total_Chart.Series[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
            Total_Chart.Series[0].IsValueShownAsLabel = true;
            Total_Chart.Series[0].LabelFormat = "{#,##} عدد";
            }
            catch { }
        }

        private void Frm_Commodity_List_Load(object sender, EventArgs e)
        {
            Show_Data();
            Chart_Info();
        }

        private void Dgv_List_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == 6)
            {
                object value = e.Value;
                if (value is DateTime)
                {
                    e.Value = new Information_Bll().GetPersianDate((DateTime)e.Value);
                    e.FormattingApplied = true;
                }
            }
        }
    }
}
