﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Compan : Form
    {
        public Frm_Compan()
        {
            InitializeComponent();
        }

        Txt_Clean tc = new Txt_Clean(); // کلاس خالی کردن تکست باکس ها

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        #region Company_Tab
        /// <summary>
        /// انتخاب تصویر
        /// </summary>
        private void Pic_select()
        {
            OpenFileDialog op = new OpenFileDialog();
            op.Filter = "Png Files | *.PNG";
            op.Title = "انتخاب لوگو";
            if (op.ShowDialog() == DialogResult.OK)
            {
                this.Pic_Logo.Image = Image.FromFile(op.FileName);
                this.Pic_Logo.Tag = op.FileName;
            }
        }

        /// <summary>
        /// ذخیره تصویر در دایرکتوری مورد نظر
        /// </summary>
        private void Piclogo()
        {
            try
            {
                if (Pic_Logo.Image != null)
                    Pic_Logo.Image.Save(Application.StartupPath + "//Data//Logo//1.png");
            }
            catch
            {
                Error.ShowBox(@"تصویر در پوشه ذخیره نشد ...
وجود پوشه تصاویر در محل نصب را بررسی نمایید .", "تصویر ذخیره نشد !");
            }
        }

        /// <summary>
        /// متود ذخیره تصویر و اطلاعات شرکت
        /// </summary>
        private void Insert_Company()
        {
            Piclogo();
            //try
            //{
                Company_Bll.Insert_Company(Convert.ToInt32(Txt_Reg_Code.Text), Txt_Name.Text.Trim(), Txt_Phone.Text.Trim(), Txt_City.Text.Trim(), Txt_Address.Text.Trim(), Txt_Description.Text.Trim());
                Ok.ShowBox(" مشخصات شرکت/ کارگاه " + Txt_Name.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
                Pic_Logo.Image = null;
//            }
//            catch
//            {
//                Error.ShowBox(@"مشخصات شرکت/ کارگاه ذخیره نشد ...
//اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
//            }
        }

        private void Btn_Select_Click(object sender, EventArgs e)
        {
            Pic_select();
        }

        private void Btn_Clear_Click(object sender, EventArgs e)
        {
            Pic_Logo.Image = null;
        }

        /// <summary>
        /// کلید ذخیره
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Reg_Code.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "شماره ثبت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Reg_Code, 5000);
                TT.Show("شماره ثبت شرکت را وارد نمایید", Txt_Reg_Code);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Name.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام شرکت/ کارگاه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Name, 5000);
                TT.Show("نام شرکت/ کارگاه را وارد نمایید", Txt_Name);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Phone.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تلفن !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Phone, 5000);
                TT.Show("تلفن شرکت/ کارگاه را وارد نمایید", Txt_Phone);
            }
            else if (Txt_Reg_Code.Text != "" && Txt_Name.Text != "" && Txt_Phone.Text != "")
            {
                Piclogo();
                Insert_Company();
            }
        }
        #endregion

        #region Persons_Tab
        /// <summary>
        /// متود ذخیره اشخاص
        /// </summary>
        private void Insert_Persons()
        {
            try
            {
                Person_Bll.Insert_Person(1, Convert.ToInt32(Txt_Person_Code.Text), Txt_Person_Name.Text.Trim(), Txt_Person_Last.Text.Trim(), Txt_Person_Phone.Text.Trim(), Txt_Person_City.Text.Trim(), Txt_Person_Adr.Text.Trim(), Cmb_Job.Text.Trim(), false);
                Ok.ShowBox(" مشخصات شخص حقیقی/ حقوقی " + Txt_Person_Name.Text + " " + Txt_Person_Last.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Person_Code"))
                {
                    Warning.ShowBox("کد مورد نظر تکراری و در فهرست موجود است .", "کد وجود دارد !");
                    Txt_Person_Code.Focus();
                }
            }
        }
        /// <summary>
        /// کلید ذخیره اشخاص
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Person_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Person_Code.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کد شخص !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Person_Code, 5000);
                TT.Show("کد شخص را وارد نمایید", Txt_Person_Code);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Person_Name.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام شخص !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Person_Name, 5000);
                TT.Show("نام شخص حقیقی/ حقوقی را وارد نمایید", Txt_Person_Name);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Person_Phone.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تلفن  !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Person_Phone, 5000);
                TT.Show("تلفن شخص را وارد نمایید", Txt_Person_Phone);
            }
            else if (string.IsNullOrWhiteSpace(Cmb_Job.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "ارتباط با شرکت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Job, 5000);
                TT.Show("نوع ارتباط شخص با شرکت را انتخاب نمایید", Cmb_Job);
            }
            else if (Txt_Person_Code.Text != "" && Txt_Person_Name.Text != "" && Txt_Person_Last.Text != "" && Cmb_Job.Text != "")
            {
                try
                {
                    Insert_Persons();
                    Cmb_Job.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات شخص حقیقی/ حقوقی ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Detail_Tab
        private void Id_DatagridCell(string Id) // انتخاب مقدار دیتاگریدویو و ریختن در تکست باکس
        {
            Txt_Person_Id.Text = Id;
        }
        /// <summary>
        /// کلید نمایش بخشی از اطلاعات شخص جهت اطلاعات تکمیلی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Selectid_Click(object sender, EventArgs e)
        {
            Frm_Halfperson FH = new Frm_Halfperson();
            FH.DataGridCell += new Action<string>(Id_DatagridCell);
            FH.ShowDialog();
        }
        /// <summary>
        /// متود ذخیره اطلاعات تکمیلی
        /// </summary>
        private void Insert_Detail()
        {
            try
            {
                Person_Detail_Bll.Insert_Person_Detail(Convert.ToInt32(Txt_Person_Id.Text), Txt_Nationalcode.Text.Trim(), Txt_Degree.Text.Trim(), Cmb_Degree.Text.Trim(), Txt_Study.Text.Trim(), Txt_Desc.Text.Trim());
                Ok.ShowBox(" مشخصات تکمیلی کارمند شماره " + Txt_Person_Id.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_National_Code"))
                {
                    Warning.ShowBox("کد ملی مورد نظر تکراری و در فهرست موجود است .", "کد ملی وجود دارد !");
                    Txt_Person_Code.Focus();
                }
            }
        }
        /// <summary>
        /// کلید ذخیره اطلاعات تکمیلی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Info_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Person_Id.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "شماره شخص !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Person_Id, 5000);
                TT.Show("شماره شخص را انتخاب نمایید", Txt_Person_Id);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Nationalcode.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کد ملی !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Nationalcode, 5000);
                TT.Show("کد ملی را وارد نمایید", Txt_Nationalcode);
            }
            else if (Txt_Person_Id.Text != "" && Txt_Nationalcode.Text != "")
            {
                try
                {
                    Insert_Detail();
                    Cmb_Degree.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات تکمیلی ذخیره نشد ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ثبت نشد !");
                }
            }
        }
        #endregion

        private void Frm_Compan_Load(object sender, EventArgs e)
        {
            //
        }

    }
}