﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Cost : Form
    {
        public Frm_Cost()
        {
            InitializeComponent();
            Dgv_Machine.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Dgv_Cost.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Dgv_Machine.Columns[3].DefaultCellStyle.Format = "c0";
            Dgv_Machine.Columns[4].DefaultCellStyle.Format = "c0";
            Dgv_Cost.Columns[2].DefaultCellStyle.Format = "c0";
        }

        Txt_Clean tc = new Txt_Clean();

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Frm_Cost_Load(object sender, EventArgs e)
        {
            Combo();
            DGV_Fill();
            Cmb_Ware.ResetText();
        }

        private void DGV_Fill()
        {
            Dgv_Machine.DataSource = new Machine_Bll().Show_Machin();
            Dgv_Cost.DataSource = new Cost_Bll().Show_Cost();
        }

        private void Combo()
        {
            Cmb_Ware.DataSource = new Warehouse_Bll().Ware_No_Combo();
            Cmb_Ware.DisplayMember = "Name";
            Cmb_Ware.ValueMember = "Id";
            Cmb_Person.DataSource = new Person_Bll().Person_No_Combo();
            Cmb_Person.DisplayMember = "Name";
            Cmb_Person.ValueMember = "Id";
        }

        #region Insert_Machine
        private void Insert_Machine()
        {
            try
            {
                Machine_Bll.Insert_Machine(Convert.ToInt32(Cmb_Ware.SelectedValue), Txt_Machine.Text.Trim(), Convert.ToInt32(Txt_Quantity.Text), Convert.ToInt32(Txt_Price.Text));
                Ok.ShowBox(" دستگاه با نام " + Txt_Machine.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch { }
        }

        private void Btn_Machine_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Ware.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Ware, 5000);
                TT.Show("نام انبار را انتخاب کنید", Cmb_Ware);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Machine.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام دستگاه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Machine, 5000);
                TT.Show("نام دستگاه را وارد نمایید", Txt_Machine);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Quantity.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تعداد !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Quantity, 5000);
                TT.Show("تعداد دستگاه را وارد نمایید", Txt_Quantity);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Price.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "قیمت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Price, 5000);
                TT.Show("قیمت دستگاه را وارد نمایید", Txt_Price);
            }
            else if (Cmb_Ware.Text != "" && Txt_Machine.Text != "" && Txt_Quantity.Text != "" && Txt_Price.Text != "")
            {
                try
                {
                    Insert_Machine();
                    Cmb_Ware.ResetText();
                    Frm_Cost_Load(null, null);
                }
                catch
                {
                    Error.ShowBox(@"مشخصات دستگاه ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Insert_Cost
        private void Insert_Cost()
        {
            try
            {
                Cost_Bll.Insert_Cost(Convert.ToInt32(Cmb_Person.SelectedValue), Txt_Cost.Text.Trim(), Convert.ToInt32(Txt_Costprice.Text), Convert.ToDateTime(Dte_Cost.Value));
                Ok.ShowBox(" هزینه " + Txt_Cost.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch { }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Person.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تنخاوه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Person, 5000);
                TT.Show("نام تنخواه را انتخاب کنید", Cmb_Person);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Cost.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "مورد هزینه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Cost, 5000);
                TT.Show("مورد هزینه را وارد نمایید", Txt_Cost);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Costprice.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "قیمت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Costprice, 5000);
                TT.Show("مبلغ هزینه را وارد نمایید", Txt_Costprice);
            }
            else if (string.IsNullOrWhiteSpace(Dte_Cost.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تاریخ !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Dte_Cost, 5000);
                TT.Show("تاریخ هزینه را وارد نمایید", Dte_Cost);
            }
            else if (Cmb_Person.Text != "" && Txt_Cost.Text != "" && Txt_Costprice.Text != "" && Dte_Cost.Text != "")
            {
                try
                {
                    Insert_Cost();
                    Cmb_Person.ResetText();
                    Frm_Cost_Load(null, null);
                    Dte_Cost.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات هزینه ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        /// <summary>
        /// تعیین فیلد تاریخ در دیتاگریدویو
        /// و تبدیل به تاریخ شمسی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Dgv_Cost_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == 4)
            {
                object value = e.Value;
                if (value is DateTime)
                {
                    e.Value = new Information_Bll().GetPersianDate((DateTime)e.Value);
                    e.FormattingApplied = true;
                }
            }
        }
    }
}
