﻿using System;
using System.Drawing;
using System.Windows.Forms;
using RGF_BLL;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Document_List : Form
    {
        private int searchIndex = -1;
        private int row;
        Usable_Bll usabal = new Usable_Bll();

        public Frm_Document_List()
        {
            InitializeComponent();
            Dgv_Invoice.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            DGV_Order.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Show_Doc_Commo()
        {
            if (Dgv_Invoice.RowCount > 0)
            {
                row = Convert.ToInt32(Dgv_Invoice.CurrentRow.Cells["Id"].Value);
                DGV_Order.DataSource = new Usable_Bll().Doc_Commodity(row);
            }
        }

        private void Type_No()
        {
            MN_Incoming.Text = " تعداد اسناد رسید کالا : " + usabal.Incoming_Count() + " برگ ";
            MN_Outcoming.Text = " تعداد اسناد حواله کالا : " + usabal.Outcoming_Count() + " برگ ";
        }

        private void Frm_Document_List_Load(object sender, EventArgs e)
        {
            Dgv_Invoice.DataSource = new Usable_Bll().Document_Info();
            Type_No();
        }

        private void Dgv_Invoice_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == 4)
            {
                object value = e.Value;
                if (value is DateTime)
                {
                    e.Value = new Information_Bll().GetPersianDate((DateTime)e.Value);
                    e.FormattingApplied = true;
                }
            }
        }

        private void Dgv_Invoice_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            Show_Doc_Commo();
        }

        private void Btn_Search_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < Dgv_Invoice.Rows.Count; i++)
                {
                    searchIndex = (searchIndex + 1) % Dgv_Invoice.Rows.Count;
                    DataGridViewRow row = Dgv_Invoice.Rows[searchIndex];
                    if (row.Cells[3].Value == null)
                    {
                        continue;
                    }
                    if (row.Cells[3].Value.ToString().Trim().StartsWith(Txt_Search.Text) || row.Cells[3].Value.ToString().Trim().ToLower().Contains(Txt_Search.Text))
                    {
                        Dgv_Invoice.CurrentCell = row.Cells[3];
                        Dgv_Invoice.FirstDisplayedScrollingRowIndex = Dgv_Invoice.Rows[row.Index].Index;
                        row = Dgv_Invoice.Rows[i];
                        return;
                    }
                }
            }
            catch { }
        }
    }
}
