﻿using System;
using System.Drawing;
using System.Windows.Forms;
using RGF_BLL;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Invoice_List : Form
    {
        private int searchIndex = -1;
        private int row;
        Usable_Bll usabal = new Usable_Bll();

        public Frm_Invoice_List()
        {
            InitializeComponent();
            Dgv_Invoice.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            DGV_Order.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            DGV_Order.Columns[3].DefaultCellStyle.Format = "c0";
            DGV_Order.Columns[4].DefaultCellStyle.Format = "c0";
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        /// <summary>
        /// نمایش سفارشات فاکتور
        /// بر اساس شماره فاکتور
        /// و مبلغ کل فاکتور در لیبل
        /// </summary>
        private void Show_Orders()
        {
            if (Dgv_Invoice.RowCount > 0)
            {
                row = Convert.ToInt32(Dgv_Invoice.CurrentRow.Cells["Id"].Value);
                DGV_Order.DataSource = new Usable_Bll().List_Order(row);
            }
            double Invoice_Payable = Convert.ToDouble(usabal.Invoice_Payable(row).Rows[0]["Invoice_Payable"].ToString());
            Lbl_Suminvoice.Text = " مبلغ فاکتور : " + Invoice_Payable.ToString("#,##0") + " ریال ";
        }

        private void Frm_Invoice_List_Load(object sender, EventArgs e)
        {
            Dgv_Invoice.DataSource = new Usable_Bll().List_Invoice();
        }

        private void Dgv_Invoice_CellMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            Show_Orders();
        }

        /// <summary>
        /// تبدیل تاریخ میلاادی به شمسی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Dgv_Invoice_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == 3)
            {
                object value = e.Value;
                if (value is DateTime)
                {
                    e.Value = new Information_Bll().GetPersianDate((DateTime)e.Value);
                    e.FormattingApplied = true;
                }
            }
        }

        /// <summary>
        /// جستجو در دیتاگریدویو بر حسب طرف حساب
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Search_Click(object sender, EventArgs e)
        {
            try
            {
                for (int i = 0; i < Dgv_Invoice.Rows.Count; i++)
                {
                    searchIndex = (searchIndex + 1) % Dgv_Invoice.Rows.Count;
                    DataGridViewRow row = Dgv_Invoice.Rows[searchIndex];
                    if (row.Cells[1].Value == null)
                    {
                        continue;
                    }
                    if (row.Cells[1].Value.ToString().Trim().StartsWith(Txt_Search.Text) || row.Cells[1].Value.ToString().Trim().ToLower().Contains(Txt_Search.Text))
                    {
                        Dgv_Invoice.CurrentCell = row.Cells[1];
                        Dgv_Invoice.FirstDisplayedScrollingRowIndex = Dgv_Invoice.Rows[row.Index].Index;
                        row = Dgv_Invoice.Rows[i];
                        return;
                    }
                }
            }
            catch { }
        }
    }
}
