﻿using System;
using System.Windows.Forms;
using RGF_UI;
using RGF_BLL;
using System.Data;
using System.Drawing;
using RGF_Inventory_Bonakdar.Properties;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Login : Form
    {
        Usable_Bll used = new Usable_Bll();
        public static string name, user_name, pass, User_Type = "";
        public static int User_Access;

        public Frm_Login()
        {
            InitializeComponent();
            Txt_Pass.UseSystemPasswordChar = true; // مخفی کردن متن تکست باکس کلمه عبور
        }

        #region Login_Code
        /// <summary>
        /// چک کردن مشخصات کاربر
        /// </summary>
        void Enter_User()
        {
            try
            {
                DataTable DT = used.User_Acc(Txt_User.Text.Trim(), Txt_Pass.Text.Trim());
                name = DT.Rows[0]["Name"].ToString();
                user_name = DT.Rows[0]["User_Name"].ToString();
                pass = DT.Rows[0]["Pass"].ToString();
                User_Type = DT.Rows[0]["User_Type"].ToString();
                User_Access = Convert.ToInt32(DT.Rows[0]["User_Access"]);
                if (user_name == Txt_User.Text.Trim() && pass == Txt_Pass.Text.Trim())
                {
                    this.FormClosing -= new System.Windows.Forms.FormClosingEventHandler(this.Frm_Login_FormClosing); // تعریف فرم کلوزینگ
                    this.Close();
                }
            }
            catch
            {
                Warning.ShowBox(@"کاربر گرامی ، نام کاربری
یا کلمه عبور اشتباه است .", "هشدار !");
                Down_Counter();
            }
        }

        /// <summary>
        /// کلید ورودد به برنامه
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Btn_Enter_Click(object sender, EventArgs e)
        {          
            if (string.IsNullOrWhiteSpace(Txt_User.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام کاربری !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_User, 5000);
                TT.Show("نام کاربری خود را وارد نمایید", Txt_User);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Pass.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کلمه عبور !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Pass, 5000);
                TT.Show("کلمه عبور خود را وارد نمایید", Txt_Pass);
            }
            else if (Txt_User.Text != "" && Txt_Pass.Text != "")
            {
                Enter_User();            
            }
        }

        private void Btn_Show_Text_MouseDown(object sender, MouseEventArgs e)
        {
            Txt_Pass.UseSystemPasswordChar = false;
        }

        private void Btn_Show_Text_MouseUp(object sender, MouseEventArgs e)
        {
            Txt_Pass.UseSystemPasswordChar = true;
        }

        private void Btn_Cancel_Click(object sender, EventArgs e)
        {
            Application.ExitThread();
        }
        #endregion

        #region Remember_Pass
        /// <summary>
        /// ذخیره نام کاربری و کلمه عبور
        /// </summary>
        void Checked()
        {
            Settings.Default.Log_Remember = true;
            Settings.Default.Username = Txt_User.Text.Trim();
            Settings.Default.Password = Txt_Pass.Text.Trim();
            Settings.Default.Save();
        }

        /// <summary>
        /// خواندن نام کاربری و کلمه عبور
        /// </summary>
        void Log_Rem()
        {
            if (Settings.Default.Log_Remember == true)
            {
                Txt_User.Text = Settings.Default.Username;
                Txt_Pass.Text = Settings.Default.Password;
            }
        }

        private void Chk_Remember_CheckedChanged(object sender, EventArgs e)
        {
            Checked();
        }

        private void Frm_Login_Load(object sender, EventArgs e)
        {
            Log_Rem();
        }
        #endregion

        #region Counter_Log
        /// <summary>
        /// غیر فعال کردن فرم ورود بعد از وارد کردن اشتباه
        /// کلمه عبور و نام کاربری برای پنج بار متوالی
        /// </summary>
        int a = 0;
        int interval = 300;
        void Down_Counter()
        {
            a++;
            Settings.Default.Log_Counter = a;
            Settings.Default.Save();
            if (Settings.Default.Log_Counter == 5)
            {
                Pln_Log.Enabled = false;
                User_Per.ShowBox(@"کاربر گرامی ، شما پنج بار متوالی نام کاربری
  و کلمه عبور را اشتباه وارد کردید .", "عدم مجوز دسترسی !");                
                var startTime = DateTime.Now;
                T_Log.Tick += (obj, args) => Lbl_Countdown.Text = (TimeSpan.FromMinutes(5) - (DateTime.Now - startTime)).ToString("hh\\:mm\\:ss") + @"
پنجره ورود بمدت پنج دقیقه غیر فعال می باشد !";
                T_Log.Start();
                Lbl_Countdown.ForeColor = Color.Black;
            }           
        }
        /// <summary>
        /// شمارنده معکوس و فعال شدن فرم ورود بعد از پنج دقیه
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void T_Log_Tick(object sender, EventArgs e)
        {
            interval--;
            if (interval == 0)
            {   
                T_Log.Stop();
                Pln_Log.Enabled = true;
                a = 0;
                interval = 300;                
                Lbl_Countdown.ForeColor = Color.Gainsboro;
            }
        }
        #endregion

        private void Frm_Login_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true; // جلوگیری از بسته پنجره با alt f4      
        }

        private void Lbk_Getpass_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            new Frm_Remember_Pass().ShowDialog();
        }

        private void Lbk_DB_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
           
        }
    }
}