﻿using Rahgoshafan_MNU;
using RGF_BLL;
using RGF_UI;
using System;
using System.Drawing;
using System.Globalization;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Main : Form
    {
        Usable_Bll usable = new Usable_Bll();
        Frm_Reg reg = new Frm_Reg();
        Chart Total_Chart;
        Chart Mouth_Chart;
        double Sell_Total;
        double Buy_Total;
        double Cost_Total;
        double Sell_Mounth;
        double Buy_Mounth;
        double Cost_Mounth;
 
        protected override void OnHandleCreated(EventArgs e) // نمایش تسکبار ویندوز در هنگام ماکسیمایز بودن فرم
        {
            base.OnHandleCreated(e);
            this.Bounds = Screen.PrimaryScreen.WorkingArea;
        }

        public Frm_Main()
        {
            InitializeComponent();
            Main_Menu.RenderMode = ToolStripRenderMode.Professional; // تغییر رنگ منو و باتون استریپ
            Main_Menu.Renderer = new BlueMenuStrip();
            Main_Menu.RenderMode = ToolStripRenderMode.Professional;
            Main_Menu.Renderer = new BlueToolStrip();
            Main_Menu.RenderMode = ToolStripRenderMode.Professional;
            Main_Menu.Renderer = new BlueToolStrip();  
            InputLanguage.CurrentInputLanguage = InputLanguage.FromCulture(new CultureInfo("fa-IR"));
        }

        private void BlueMenuStripMenuItem_Click(object sender, EventArgs e) // تغییر رنگ منو و باتون استریپ
        {
            Main_Menu.RenderMode = ToolStripRenderMode.Professional;
            Main_Menu.Renderer = new BlueMenuStrip();
        }

        #region Main_Form Display
        private void Frm_Main_Load(object sender, EventArgs e)
        {
            new Frm_Login().ShowDialog();
            Expire();
            Show_Date();
            Chart_Info();
            Chart_Info2();
        }

        /// <summary>
        /// آمار و ارقام داشبورد
        /// </summary>
        private void Show_Date()
        {
            try
            {
                Lbl_Date.Text = new Date_Full(DateTime.Now).Short_PrsDate(); // نمایش تاریخ و تقویم
                Lbl_User.Text = " کاربر حاضر : " + Frm_Login.name + @"
حساب کاربری : " + Frm_Login.User_Type; // نام و سطح دسترسی کاربر جاری
                Lbl_One.Text = " اشخاص و کارکنان : " + new Person_Bll().Person_Num() + " نفر ";
                Lbl_Ware_No.Text = " انبارهای موجود : " + new Warehouse_Bll().Warehouse_Num() + " واحد ";
                Lbl_Two.Text = " گروه های کالا : " + new Group_Bll().Group_No() + " گروه ";
                Lbl_Commo_No.Text = " کالاهای ثبت شده : " + new Commodity_Bll().Commo_No() + " قلم ";
                Lbl_Invoice_No.Text = " فاکتورهای ثبت شده : " + new Invoice_Bll().Invoice_No() + " برگ ";
                Lbl_Coc_No.Text = " اسناد ثبت شده : " + new Document_Bll().Doc_No() + " سند ";
                Lbl_Machine_No.Text = " تجهیزات انبارها : " + new Machine_Bll().Machin_No() + " دستگاه ";
                Lbl_Cost_No.Text = " هزینه های جاری : " + new Cost_Bll().Cost_No() + " مورد ";
                Sell_Total = new Usable_Bll().Total_Sell_Price();
                Buy_Total = new Usable_Bll().Total_Buy_Price();
                Cost_Total = new Usable_Bll().Total_Cost_Price();
                Sell_Mounth = new Usable_Bll().Mounth_Sell();
                Buy_Mounth = new Usable_Bll().Mounth_Buy();
                Cost_Mounth = new Usable_Bll().Mounth_Cost();
                Lbl_infoproduct.Text = " پر فروش ترین : " + usable.Dashboard_Up().Rows[0]["Expr1"].ToString() + @"
فروش : " + usable.Dashboard_Up().Rows[0]["Total_Quantity"].ToString() + " عدد " + @"
کم فروش ترین : " + usable.Dashboard_Down().Rows[0]["Expr1"].ToString() + @"
فروش : " + usable.Dashboard_Down().Rows[0]["Total_Quantity"].ToString() + " عدد ";
            }
            catch { }
        }

        /// <summary>
        /// رسم نمودار با مقادیر دریافتی از دیتابیس
        /// </summary>
        private void Chart_Info()
        {
            try
            {
                Total_Chart = new Chart();
                ChartArea Area = new ChartArea();
                Total_Chart.ChartAreas.Add(Area);
                Series S_1 = new Series();
                Total_Chart.Series.Add(S_1);
                double[] yval = { Buy_Total, Sell_Total, Cost_Total };
                string[] xval = { "خرید کل", "فروش کل", "هزینه کل" };
                Total_Chart.Series[0].Points.DataBindXY(xval, yval);
                Total_Chart.Series[0].ChartType = SeriesChartType.Doughnut;
                Total_Chart.Location = new System.Drawing.Point(10, 0);
                Total_Chart.Size = new System.Drawing.Size(370, 300);
                Total_Chart.Legends.Add("num");
                this.Controls["Pln_Chart"].Controls.Clear();
                this.Controls["Pln_Chart"].Controls.Add(Total_Chart);
                Total_Chart.BackColor = Color.White;
                Total_Chart.ChartAreas[0].BackColor = Color.Transparent;
                Total_Chart.Series[0].Points[0].Color = Color.FromArgb(137, 196, 244);
                Total_Chart.Series[0].Points[1].Color = Color.FromArgb(209, 222, 192);
                Total_Chart.Series[0].Points[2].Color = Color.FromArgb(253, 227, 227);
                Total_Chart.Legends[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Total_Chart.Series[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Total_Chart.Series[0].IsValueShownAsLabel = true;
                Total_Chart.Series[0].LabelFormat = "{#,##} ریال";
            }
            catch { }
        }

        void Chart_Info2()
        {
            try
            {
                Mouth_Chart = new Chart();
                ChartArea Area = new ChartArea();
                Mouth_Chart.ChartAreas.Add(Area);
                Series S_1 = new Series();
                Mouth_Chart.Series.Add(S_1);
                double[] yval = { Buy_Mounth, Sell_Mounth, Cost_Mounth };
                string[] xval = { "خرید ماه", "فروش ماه", "هزینه ماه" };
                Mouth_Chart.Series[0].Points.DataBindXY(xval, yval);
                Mouth_Chart.Series[0].ChartType = SeriesChartType.Doughnut;
                Mouth_Chart.Location = new System.Drawing.Point(10, 0);
                Mouth_Chart.Size = new System.Drawing.Size(370, 300);
                Mouth_Chart.Legends.Add("num");
                this.Controls["Pln_Chart2"].Controls.Clear();
                this.Controls["Pln_Chart2"].Controls.Add(Mouth_Chart);
                Mouth_Chart.BackColor = Color.White;
                Mouth_Chart.ChartAreas[0].BackColor = Color.Transparent;
                Mouth_Chart.Series[0].Points[0].Color = Color.FromArgb(137, 196, 244);
                Mouth_Chart.Series[0].Points[1].Color = Color.FromArgb(209, 222, 192);
                Mouth_Chart.Series[0].Points[2].Color = Color.FromArgb(253, 227, 227);
                Mouth_Chart.Legends[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Mouth_Chart.Series[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Mouth_Chart.Series[0].IsValueShownAsLabel = true;
                Mouth_Chart.Series[0].LabelFormat = "{#,##} ریال";
            }
            catch { }
        }

        #region Header & Footer        
        bool a = false;
        /// <summary>
        /// نمایش تقویم در پنل فوتر با حالت کشویی
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Lbl_Date_Click(object sender, EventArgs e)
        {
            switch (a)
            {
                case false: T_One.Enabled = true; T_Two.Enabled = false; a = true;
                    Lbl_Datefull.Text = " امروز : " + new Date_Full(DateTime.Now).Complete_PrsDate() + @"
" + new Date_Full(DateTime.Now).taghvim();
                    break;
                case true: T_Two.Enabled = true; T_One.Enabled = false; a = false;
                    break;
            }
        }

        private void T_One_Tick(object sender, EventArgs e)
        {
            int w = 0;
            w = Pln_Date.Height;
            if (w < 75)
            {
                Pln_Date.Height = Pln_Date.Height + 1;
            }
        }

        private void T_Two_Tick(object sender, EventArgs e)
        {
            int w = 0;
            w = Pln_Date.Height;
            if (w > 30)
            {
                Pln_Date.Height = Pln_Date.Height - 1;
            }        
        }
        #endregion

        private void Expire() // فعالسازی برنامه
        {
            if (Properties.Settings.Default.Reg_Check == true)
            {
                Lbl_Details.Text = String.Empty;
                MN_Active.Enabled = false;
                MN_Active.Text = "نرم افزار ثبت شده است";
            }
            else
            {
                new Serial().Trial_Expired();
                Btn_Commodity.Enabled = false;
                Btn_Report.Enabled = false;
                Btn_Incoming.Enabled = false;
                Btn_Suppliers.Enabled = false;
            }
        }

        /// <summary>
        /// کلید میانبر در فرم
        /// اسکپ جهت بستن فرم
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                Exit.ShowBox("قصد خروج از برنامه را دارید ؟", "خروج از برنامه !");
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Btn_Exit_Click(object sender, EventArgs e)
        {
            Exit.ShowBox("قصد خروج از برنامه را دارید ؟", "خروج از برنامه !");
        }       

        private void Btn_Min_Click(object sender, EventArgs e)
        {
            WindowState = FormWindowState.Minimized;
        }
        #endregion        

        private void MN_Tut_Click(object sender, EventArgs e)
        {
            //// باز شدن فایل آموزش
        }

        private void Btn_Warehouse_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Warehouse FW = new Frm_Warehouse();
                MaskedDialog.ShowDialog(this, FW); // فراخوانی کلاس تیره شدن پشت فرم هنگام باز شدن فرم
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }             
        }

        private void Btn_Company_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Compan FC = new Frm_Compan();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }            
        }

        private void Btn_Commodity_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Commodity FC = new Frm_Commodity();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                   @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }             
        }

        private void Btn_Suppliers_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 3 || Frm_Login.User_Access == 1)
            {
                Frm_Invoice FI = new Frm_Invoice();
                MaskedDialog.ShowDialog(this, FI);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }            
        }

        private void Btn_Incoming_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Document FD = new Frm_Document();
                MaskedDialog.ShowDialog(this, FD);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }            
        }

        private void Btn_Finance_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 4 || Frm_Login.User_Access == 1)
            {
                Frm_Cost FC = new Frm_Cost();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }     
        }

        private void Btn_Report_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Report FR = new Frm_Report();
                MaskedDialog.ShowDialog(this, FR);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void Btn_Database_Click(object sender, EventArgs e)
        {
            Frm_Search FS = new Frm_Search();
            MaskedDialog.ShowDialog(this, FS);
        }

        private void MN_About_Click(object sender, EventArgs e)
        {
            Aboute about = new Aboute();
            MaskedDialog.ShowDialog(this, about);
        }

        private void MN_Warehouse_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Compan FC = new Frm_Compan();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Commo_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Warehouse FW = new Frm_Warehouse();
                MaskedDialog.ShowDialog(this, FW);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Supplier_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Commodity FC = new Frm_Commodity();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                   @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Rep_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 3 || Frm_Login.User_Access == 1)
            {
                Frm_Invoice FI = new Frm_Invoice();
                MaskedDialog.ShowDialog(this, FI);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Document_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Document FD = new Frm_Document();
                MaskedDialog.ShowDialog(this, FD);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Cost_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 4 || Frm_Login.User_Access == 1)
            {
                Frm_Cost FC = new Frm_Cost();
                MaskedDialog.ShowDialog(this, FC);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Exit_Click(object sender, EventArgs e)
        {
            Exit.ShowBox("قصد خروج از برنامه را دارید ؟", "خروج از برنامه !");
        }

        private void MN_Active_Click(object sender, EventArgs e)
        {            
            Frm_Reg FR = new Frm_Reg();
            MaskedDialog.ShowDialog(this, FR);
        }

        private void MN_Mail_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Report FR = new Frm_Report();
                MaskedDialog.ShowDialog(this, FR);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Note_Click(object sender, EventArgs e)
        {
            Frm_Search FS = new Frm_Search();
            MaskedDialog.ShowDialog(this, FS);
        }

        private void MN_Category_Click(object sender, EventArgs e)
        {
            Frm_Commodity_List FCL = new Frm_Commodity_List();
            MaskedDialog.ShowDialog(this, FCL);
        }

        private void MN_Invoice_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 4 || Frm_Login.User_Access == 1)
            {
            Frm_Invoice_List FIL = new Frm_Invoice_List();
            MaskedDialog.ShowDialog(this, FIL);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_In_Out_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 2 || Frm_Login.User_Access == 1)
            {
                Frm_Document_List FIL = new Frm_Document_List();
                MaskedDialog.ShowDialog(this, FIL);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Person_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Show_Person FSP = new Frm_Show_Person(); // فهرست اشخاص
                MaskedDialog.ShowDialog(this, FSP);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_User_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_User FIL = new Frm_User();
                MaskedDialog.ShowDialog(this, FIL);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Email_Click(object sender, EventArgs e)
        {
            //ایمیل
        }

        private void MN_Set_Click(object sender, EventArgs e)
        {
            //تنظیمات
        }

        private void MN_Database_Click(object sender, EventArgs e)
        {
            //دیتابیس
        }

        private void MN_Backup_Click(object sender, EventArgs e)
        {
            if (Frm_Login.User_Access == 1)
            {
                Frm_Backup FIL = new Frm_Backup();
                MaskedDialog.ShowDialog(this, FIL);
            }
            else
            {
                User_Per.ShowBox(" کاربر ، " + Frm_Login.name + " ! " +
                  @"
شما مجوز دسترسی به این بخش از برنامه را ندارید", "عدم مجوز دسترسی");
            }
        }

        private void MN_Refresh_Click(object sender, EventArgs e)
        {
            Show_Date();
            Chart_Info();
            Chart_Info2();
        }
    }
}
