﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_New_Commodity : Form
    {
        public Frm_New_Commodity()
        {
            InitializeComponent();
        }

        Txt_Clean tc = new Txt_Clean();
        private string str_selectpic = ""; // ذخیره نام تصویر
        private string str_path = ""; // ذخیره نام تصویر

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Frm_New_Commodity_Load(object sender, EventArgs e)
        {
            Combo();           
        }

        private void Combo()
        {
            Cmb_Virtual.DataSource = new Virtual_Bll().Virtual_No_Combo();
            Cmb_Virtual.DisplayMember = "Name";
            Cmb_Virtual.ValueMember = "Id";
            Cmb_Group.DataSource = new Group_Bll().Gro_No_Combo();
            Cmb_Group.DisplayMember = "Name";
            Cmb_Group.ValueMember = "Id";
            Cmb_Commodity.DataSource = new Commodity_Bll().Commo_No_Combo();
            Cmb_Commodity.DisplayMember = "Name";
            Cmb_Commodity.ValueMember = "Id";
            Cmb_Commo.DataSource = new Commodity_Bll().Commo_No_Combo();
            Cmb_Commo.DisplayMember = "Name";
            Cmb_Commo.ValueMember = "Id";
            Cmb_Virtual.ResetText();
            Cmb_Group.ResetText();
            Cmb_Commodity.ResetText();
            Cmb_Commo.ResetText();
        }

        #region Insert_Commodity
        private void Select_Img()
        {
            OpenFileDialog OPD = new OpenFileDialog();
            OPD.Filter = "all picture  |*.jpg;*.png;";
            OPD.RestoreDirectory = true;
            if (OPD.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                str_selectpic = OPD.SafeFileName;
                str_path = OPD.FileName;
                Pic_Logo.Image = Image.FromFile(str_path);
            }
        }

        private void Btn_Select_Click(object sender, EventArgs e)
        {
            Select_Img();
        }

        private void Btn_Clear_Click(object sender, EventArgs e)
        {
            Pic_Logo.Image = null;
        }

        private void Insert_Commodity()
        {
            try
            {
                Commodity_Bll.Insert_Commodity(Convert.ToInt32(Txt_Commo_Code.Text), Convert.ToInt32(Cmb_Group.SelectedValue), Convert.ToInt32(Cmb_Virtual.SelectedValue), Txt_Commodity.Text.Trim(), Txt_Commo_Desc.Text.Trim(), str_selectpic);
                Ok.ShowBox(" کالا با نام " + Txt_Commodity.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Commodity_Code"))
                {
                    Warning.ShowBox("کد کالا تکراری و در فهرست موجود است .", "کد کالا !");
                    Txt_Commo_Code.Focus();
                }
                if (ex.Message.Contains("IX_Name_Com"))
                {
                    Warning.ShowBox("نام کالا تکراری و در فهرست موجود است .", "نام کالا !");
                    Txt_Commodity.Focus();
                }
            }
        }

        private void Btn_Commo_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Commo_Code.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کد کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Commo_Code, 5000);
                TT.Show("کد کالا را وارد نمایید", Txt_Commo_Code);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Commodity.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Commodity, 5000);
                TT.Show("نام کالا را وارد نمایید", Txt_Commodity);
            }
            else if (string.IsNullOrWhiteSpace(Cmb_Virtual.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = " قسمت از انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Virtual, 5000);
                TT.Show("قسمت از انبار را انتخاب کنید", Cmb_Virtual);
            }
            else if (string.IsNullOrWhiteSpace(Cmb_Group.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام گروه !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Group, 5000);
                TT.Show("نام گروه کالا را انتخاب کنبد", Cmb_Group);
            }
            else if (Txt_Commo_Code.Text != "" && Txt_Commodity.Text != "" && Cmb_Virtual.Text != "" && Cmb_Group.Text != "")
            {
                Frm_Commodity FC = (Frm_Commodity)Application.OpenForms["Frm_Commodity"]; // در دسترس قرار گرفتن متدهای فرم کالا
                try
                {
                    Insert_Commodity();
                    if (Pic_Logo.Image != null)
                    {
                        System.IO.File.Copy(str_path, "Data\\Image\\" + str_selectpic, true); // ذخیره عکس در پوشه مورد نظر
                    }
                    str_path = "";
                    str_selectpic = "";
                    Pic_Logo.Image = null;
                    Cmb_Virtual.ResetText();
                    Cmb_Group.ResetText();
                    Frm_New_Commodity_Load(null, null);
                    FC.Gridview(); // بازخوانی متد
                    FC.Dgv_Commo.Update();
                    FC.Dgv_Commo.Refresh(); // رفرش کردن دیتاگریدویو جهت نمایش کالای درج شده جدید          
                }
                catch
                {
                    Error.ShowBox(@"مشخصات کالا ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Insert_Detail
        private void Insert_Commodity_Detail()
        {
            try
            {
                Commo_Detail_Bll.Insert_Commo_Detail(Convert.ToInt32(Cmb_Commodity.SelectedValue), Txt_Qualify.Text.Trim(), Convert.ToInt32(Txt_Weight.Text), Txt_Color.Text.Trim());
                Ok.ShowBox(" جزئیات کالا با نام " + Cmb_Commodity.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch { }
        }

        private void Btn_Detail_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Commodity.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Commodity, 5000);
                TT.Show("نام کالا را انتخاب کنید", Cmb_Commodity);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Qualify.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کیفیت کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Qualify, 5000);
                TT.Show("کیفیت کالا را وارد نمایید", Txt_Qualify);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Weight.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = " رنگ کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Weight, 5000);
                TT.Show("رنگ کالا را وارد نمایید", Txt_Weight);
            }
            else if (Cmb_Commodity.Text != "" && Txt_Qualify.Text != "" && Txt_Weight.Text != "")
            {
                try
                {
                    Insert_Commodity_Detail();
                    Cmb_Commodity.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات کالا ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Insert_Unit
        private void Insert_Commodity_Unit()
        {
            try
            {
                Unit_Bll.Insert_Commo_Detail(Convert.ToInt32(Cmb_Commo.SelectedValue), Txt_Unit.Text.Trim());
                Ok.ShowBox(" واحد کالا با نام " + Txt_Unit.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch { }
        }

        private void Btn_Unit_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Commo.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Commo, 5000);
                TT.Show("نام کالا را انتخاب کنید", Cmb_Commo);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Unit.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = " واحد کالا !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Unit, 5000);
                TT.Show("واحد کالا را وارد نمایید", Txt_Unit);
            }
            else if (Cmb_Commo.Text != "" && Txt_Unit.Text != "")
            {
                try
                {
                    Insert_Commodity_Unit();
                    Cmb_Commo.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"واحد کالا ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion
    }
}
