﻿using System;
using System.Drawing;
using RGF_UI;
using RGF_BLL;
using RGF_Inventory_Bonakdar.Properties;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Reg : Form
    {
        string Cpu, Mboard;
        Serial SR = new Serial();

        public Frm_Reg()
        {
            InitializeComponent();
        }

        private void Read_Info()
        {
            Cpu = Information_Bll.Processor_SR();
            Mboard = Information_Bll.MainBoard_SR();
            Txt_Reg.Text = Cpu + Mboard;
        }

        private void Reg_Check()
        {
            if (Settings.Default.Reg_Check == false)
            {
                Read_Info();
            }
        }

        private void Frm_Reg_Load(object sender, EventArgs e)
        {
            Wait.ShowLoadingScreen(this);
            try
            {
                Reg_Check();
            }
            catch
            {
                Warning.ShowBox("عدم خواندن اطلاعات سخت افزاری","هشدار");
            }
            Wait.CloseLoadingScreen();
            this.Activate();
        }

        private void Btn_Reg_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Code.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "سریال ثبت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Code, 5000);
                TT.Show("سریال ثبت را وارد نمایید", Txt_Code);
            }            
            else
            {
                try
                {
                    if (Txt_Code.Text.Trim() == SR.SN_Code()) // اگر سریال کدگذاری شده و کد ورودی برابر بود
                    {
                        Settings.Default.Reg_Check = true;     // مقدار متغیر ترو شده           
                        Settings.Default.Save();               // ذخیره شود 
                        Ok.ShowBox(@"با تشکر ...
نرم افزار ثبت و محدودیت استفاده رفع شد ! .", "انجام شد");
                    }
                    else
                    {
                        Warning.ShowBox(@"کد وارد شده صحیح نمی باشد ...
جهت دریافت کد با واحد پشتیبانی تماس حاصل فرمایید .", "هشدار");
                        Application.ExitThread();
                    }
                }
                catch
                {
                    Error.ShowBox(@"خطا در ثبت نرم افزار ...
با واحد پشتیبانی تماس حاصل فرمایید .", "خطا");
                    Application.ExitThread();
                }
            }
        }
    }
}