﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Drawing;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Report : Form
    {
        public Frm_Report()
        {
            InitializeComponent();
            Dgv_Down_Commodity.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Dgv_Down_Commodity.DataSource = new Usable_Bll().Inventory_Commodity_Down();
        }

        Usable_Bll usable = new Usable_Bll();
        NumtoStr nms = new NumtoStr();
        Chart Total_Chart;
        double Sell_Total;
        double Buy_Total;
        double Cost_Total;
        double Money;
        double Sell_Mounth;
        double Buy_Mounth;
        double Cost_Mounth;
        double Money_Mounth;
        double Invoice;
        double Day_Sell;
        double Day_Buy;
        double Day_Cost;
        double Day_Money;

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Load_Data()
        {
            try
            {
            Sell_Total = new Usable_Bll().Total_Sell_Price();
            Buy_Total = new Usable_Bll().Total_Buy_Price();
            Cost_Total = new Usable_Bll().Total_Cost_Price();
            Sell_Mounth = new Usable_Bll().Mounth_Sell();
            Buy_Mounth = new Usable_Bll().Mounth_Buy();
            Cost_Mounth = new Usable_Bll().Mounth_Cost();
            Day_Sell = new Usable_Bll().Day_Sell();
            Day_Buy = new Usable_Bll().Day_Buy();
            Day_Cost = new Usable_Bll().Day_Cost();
            }
            catch { }
        }

        private void Show_Data()
        {
            try
            {
                Invoice = Convert.ToDouble(usable.Dashboard_Invoice().Rows[0]["Total_Sum"]);
                Lbl_infoproduct.Text = " پر فروش ترین : " + usable.Dashboard_Up().Rows[0]["Expr1"].ToString() + @"
فروش : " + usable.Dashboard_Up().Rows[0]["Total_Quantity"].ToString() + " عدد " + @"
کم فروش ترین : " + usable.Dashboard_Down().Rows[0]["Expr1"].ToString() + @"
فروش : " + usable.Dashboard_Down().Rows[0]["Total_Quantity"].ToString() + " عدد ";
                Lbl_Infoinvoice.Text = " شماره فاکتور : " + usable.Dashboard_Invoice().Rows[0]["Invoice_Id"].ToString() + @"
مبلغ فاکتور : " + Invoice.ToString("#,##0") + " ریال " + @"
سفارش : " + usable.Dashboard_Invoice().Rows[0]["Order_Count"].ToString() + " قلم کالا ";
                Money = Sell_Total - (Buy_Total + Cost_Total);
                Money_Mounth = Sell_Mounth - (Buy_Mounth + Cost_Mounth);
                Lbl_Mounth.Text = " خرید ماه : " + Buy_Mounth.ToString("#,##0") + " ریال " + @"
فروش ماه : " + Sell_Mounth.ToString("#,##0") + " ریال " + @"
هزینه های ماه : " + Cost_Mounth.ToString("#,##0") + " ریال " + @"
سود حاصل : " + Money_Mounth.ToString("#,##0") + " ریال ";
                Day_Money = Day_Sell - (Day_Buy + Day_Cost);
                Lbl_Commo_Count.Text = " خرید روز : " + Day_Buy.ToString("#,##0") + " ریال " + @"
فروش روز : " + Day_Sell.ToString("#,##0") + " ریال " + @"
هزینه های روز : " + Day_Cost.ToString("#,##0") + " ریال " + @"
سود حاصل : " + Day_Money.ToString("#,##0") + " ریال ";
            }
            catch { }
        }

        private void Show_Full_Data()
        {
            try
            {
                Lbl_Buy.Text = " خرید به حروف : " + nms.num2str(Buy_Total.ToString()) + "ریال";
                Lbl_Sell.Text = " فروش به حروف : " + nms.num2str(Sell_Total.ToString()) + "ریال";
                Lbl_Cost.Text = " هزینه به حروف : " + nms.num2str(Cost_Total.ToString()) + "ریال";
                Lbl_Sod.Text = " سود به حروف : " + nms.num2str(Money.ToString()) + "ریال";
            }
            catch { }
        }

        private void Chart_Info()
        {         
            try
            {
                Total_Chart = new Chart();
                ChartArea Area = new ChartArea();
                Total_Chart.ChartAreas.Add(Area);
                Series S_1 = new Series();
                Total_Chart.Series.Add(S_1);
                double[] yval = { Buy_Total, Sell_Total, Cost_Total, Money };
                string[] xval = { "خرید کل", "فروش کل", "هزینه کل", "سود کل" };
                Total_Chart.Series[0].Points.DataBindXY(xval, yval);
                Total_Chart.Series[0].ChartType = SeriesChartType.Doughnut;
                Total_Chart.Location = new System.Drawing.Point(10, 0);
                Total_Chart.Size = new System.Drawing.Size(360, 300);
                Total_Chart.Legends.Add("num");
                this.Controls["Pln_Chart"].Controls.Clear();
                this.Controls["Pln_Chart"].Controls.Add(Total_Chart);
                Total_Chart.BackColor = Color.White;
                Total_Chart.ChartAreas[0].BackColor = Color.Transparent;
                Total_Chart.Series[0].Points[0].Color = Color.FromArgb(137, 196, 244);
                Total_Chart.Series[0].Points[1].Color = Color.FromArgb(209, 222, 192);
                Total_Chart.Series[0].Points[2].Color = Color.FromArgb(253, 227, 227);
                Total_Chart.Series[0].Points[3].Color = Color.FromArgb(203, 207, 127);
                Total_Chart.Legends[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Total_Chart.Series[0].Font = new Font("B Yekan", 8, FontStyle.Regular);
                Total_Chart.Series[0].IsValueShownAsLabel = true;
                Total_Chart.Series[0].LabelFormat = "{#,##} ریال";
            }
            catch { }
        }

        private void Frm_Report_Load(object sender, EventArgs e)
        {
            Wait.ShowLoadingScreen(this);
            try
            {
                Load_Data();
                Show_Data();
                Show_Full_Data();
                Chart_Info();
            }
            catch { }
            Wait.CloseLoadingScreen();
            this.Activate();
        }
    }
}
