﻿using Rahgoshafan_MNU;
using RGF_BLL;
using RGF_DAL;
using RGF_UI;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Search : Form
    {
        private string Order_Warehouse;
        private string Order_Category;
        SqlConnection Con = new SqlConnection(Properties.Settings.Default.Connect);

        public Frm_Search()
        {
            InitializeComponent();
            Dgv_Commo.AlternatingRowsDefaultCellStyle.BackColor = System.Drawing.Color.FromArgb(216, 232, 237);
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Combo()
        {
            Cmb_Ware.DataSource = new Warehouse_Bll().Ware_No_Combo();
            Cmb_Ware.DisplayMember = "Name";
            Cmb_Cate.DataSource = new Category_Bll().Cat_No_Combo();
            Cmb_Cate.DisplayMember = "Name";
            Cmb_Group.DataSource = new Group_Bll().Gro_No_Combo();
            Cmb_Group.DisplayMember = "Name";
            Cmb_Ware.ResetText();
            Cmb_Cate.ResetText();
            Cmb_Group.ResetText();
        }

        void Tick_Order_By()
        {
            if (Rdb_Warehouse.Checked == true)
                Order_Warehouse = "ASC";
            if (Rdb_Category.Checked == true)
                Order_Category = "ASC";
        }

        private void Frm_Search_Load(object sender, EventArgs e)
        {
            Combo();
        }

        private void Btn_Search_Click(object sender, EventArgs e)
        {
            Tick_Order_By();
            SqlCommand cmd = new SqlCommand("SP_AdvanceSearch", Con);
            cmd.CommandType = CommandType.StoredProcedure;
            cmd.Parameters.AddWithValue("@Code", Txt_Code.Text.Trim() != "" ? (object)Convert.ToInt32(Txt_Code.Text) : DBNull.Value);
            cmd.Parameters.AddWithValue("@Name", Txt_Commodity.Text.Trim() != "" ? (object)Txt_Commodity.Text : DBNull.Value);
            cmd.Parameters.AddWithValue("@Warehouse", Cmb_Ware.Text.Trim() != "" ? (object)Cmb_Ware.Text : DBNull.Value);
            cmd.Parameters.AddWithValue("@Category", Cmb_Cate.Text.Trim() != "" ? (object)Cmb_Cate.Text : DBNull.Value);
            cmd.Parameters.AddWithValue("@Group", Cmb_Group.Text.Trim() != "" ? (object)Cmb_Group.Text : DBNull.Value);
            cmd.Parameters.AddWithValue("@OrderBy", Order_Warehouse != "" ? (object)Order_Warehouse : DBNull.Value);
            cmd.Parameters.AddWithValue("@OrderBy_Two", Order_Category != "" ? (object)Order_Category : DBNull.Value);
            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = cmd;
            DataTable dt = new DataTable();
            da.Fill(dt);
            Dgv_Commo.DataSource = dt;
            Lbl_Result.Text = "تعداد اقلام یافته شده : " + (Dgv_Commo.Rows.Count).ToString("n0") + " قلم ";
        }

        private void Btn_Refresh_Click(object sender, EventArgs e)
        {
            Cmb_Ware.ResetText();
            Cmb_Cate.ResetText();
            Cmb_Group.ResetText();
            Order_Warehouse = String.Empty;
            Order_Category = String.Empty;
            Rdb_Warehouse.Checked = false;
            Rdb_Category.Checked = false;
            Lbl_Result.Text = "...";
        }
    }
}
