﻿using RGF_BLL;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Show_Person : Form
    {
        public Frm_Show_Person()
        {
            InitializeComponent();
            Dgv_Users.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Dgv_Users.Columns[2].DefaultCellStyle.Format = "c0";
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Frm_Show_Person_Load(object sender, EventArgs e)
        {
            Dgv_Users.DataSource = new Usable_Bll().Show_Cost();
        }

        private void Dgv_Users_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            if (e.ColumnIndex == 4)
            {
                object value = e.Value;
                if (value is DateTime)
                {
                    e.Value = new Information_Bll().GetPersianDate((DateTime)e.Value);
                    e.FormattingApplied = true;
                }
            }
        }
    }
}
