﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_User : Form
    {
        Txt_Clean tc = new Txt_Clean();
        private int account;
        private string type;

        public Frm_User()
        {
            InitializeComponent();
            Dgv_Users.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
            Txt_Pass.UseSystemPasswordChar = true; // مخفی کردن متن تکست باکس کلمه عبور
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Frm_User_Load(object sender, System.EventArgs e)
        {
            Dgv_Users.DataSource = new Usable_Bll().Users_Info();
        }

        private void Account()
        {
            if (RB_Admin.Checked == true)
            {
                account = 1;
                type = "مدیر";
            }
            if (RB_Warehouse.Checked == true)
            {
                account = 2;
                type = "انباردار";
            }
            if (RB_Seller.Checked == true)
            {
                account = 3;
                type = "فروشنده";
            }
            if (RB_Agent.Checked == true)
            {
                account = 4;
                type = "تنخواه";
            }
        }

        #region Insert
        private void New_User()
        {
            if (RB_Admin.Checked || RB_Agent.Checked || RB_Seller.Checked || RB_Warehouse.Checked)
            {
                try
                {
                    Usable_Bll.Insert_User(Txt_Ful_Name.Text.Trim(), Txt_Username.Text.Trim(), Txt_Pass.Text.Trim(), type, account, Cmb_Question.Text, Txt_Answer.Text.Trim());
                    Ok.ShowBox(" کاربر با نام " + Txt_Ful_Name.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                    tc.ClearTxt(this);
                }
                catch
                {
                    Error.ShowBox("عملیات ثبت کاربربا خطا مواجه شد .", "خطا !");
                }
            }
            else
            {
                Warning.ShowBox("حساب کاربری را تعیین نمایید .", "هشدار");
            }
            RB_Agent.Checked = false;
            RB_Admin.Checked = false;
            RB_Seller.Checked = false;
            RB_Warehouse.Checked = false;
        }

        private void Btn_Add_Click(object sender, System.EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Ful_Name.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام و نام خانودگی !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Ful_Name, 5000);
                TT.Show("نام و نام خانودگی خود را وارد نمایید", Txt_Ful_Name);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Username.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام کاربری !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Username, 5000);
                TT.Show("نام کاربری خود را وارد نمایید", Txt_Username);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Pass.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "کلمه عبور !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Pass, 5000);
                TT.Show("کلمه عبور خود را وارد نمایید", Txt_Pass);
            }
            else if (string.IsNullOrWhiteSpace(Cmb_Question.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "سوال امنیتی !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Question, 5000);
                TT.Show("سوال امنیتی را انتخاب کنید", Cmb_Question);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Answer.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "جواب سوال !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Answer, 5000);
                TT.Show("جواب سوال امنیتی را وارد نمایید", Txt_Answer);
            }
            else if (Txt_Ful_Name.Text != "" && Txt_Username.Text != "" && Txt_Pass.Text != "" && Cmb_Question.Text != "" && Txt_Answer.Text != "")
            {
                Account();
                New_User();
                Frm_User_Load(null, null);
                Cmb_Question.ResetText();
            }
        }
#endregion

        #region Delete
        private void Del_User()
        {
            int row = Convert.ToInt32(Dgv_Users.CurrentRow.Cells["Id"].Value);
            new Usable_Bll().Del_User(row);
            Frm_User_Load(null, null);
        }

        private void Btn_Del_Click(object sender, System.EventArgs e)
        {
            string result = Question.ShowBox("آیا کاربر مورد نظر حذف شود ؟", "حذف");
            if (result.Equals("2"))
            {
                Del_User();
            }
            else if (result.Equals("1"))
            { }
        }
        #endregion
    }
}
