﻿using RGF_BLL;
using RGF_UI;
using System;
using System.Data.SqlClient;
using System.Drawing;
using System.Windows.Forms;

namespace RGF_Inventory_Bonakdar
{
    public partial class Frm_Warehouse : Form
    {
        Txt_Clean tc = new Txt_Clean();

        public Frm_Warehouse()
        {
            InitializeComponent();
            Dgv_Warehouse.AlternatingRowsDefaultCellStyle.BackColor = Color.FromArgb(216, 232, 237);
        }

        /// <summary>
        /// بستن پنجره با زدن اسکپ
        /// scape for close
        /// </summary>
        /// <param name="msg"></param>
        /// <param name="keyData"></param>
        /// <returns></returns>
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (keyData == Keys.Escape)
            {
                this.Close();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void Show_Warehouse()
        {
            Dgv_Warehouse.DataSource = Warehouse_Bll.Full_Show();
        }

        #region Insert_Type
        private void Insert_Type()
        {
            try
            {
            Type_Bll.Insert_Type(Txt_Type.Text.Trim(), Txt_Description.Text.Trim());
                Ok.ShowBox(" انبار از نوع " + Txt_Type.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Name_WT"))
                {
                    Warning.ShowBox("نوع انبار تکراری و در فهرست موجود است .", "نوع انبار !");
                    Txt_Type.Focus();
                }
            }
        }

        private void Btn_Type_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Type.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نوع انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Type, 5000);
                TT.Show("نوع انبار را وارد نمایید", Txt_Type);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Description.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "توضیحات !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Description, 5000);
                TT.Show("توضیحات را وارد نمایید", Txt_Description);
            }
            else if (Txt_Type.Text != "" && Txt_Description.Text != "")
            {
                try
                {
                    Insert_Type();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات نوع انبار ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Insert_Warehouse
        private void Id_DatagridCell(string Id) // انتخاب مقدار دیتاگریدویو و ریختن در تکست باکس
        {
            Txt_Type_Id.Text = Id;
        }

        private void Btn_Selectid_Click(object sender, EventArgs e)
        {
            Frm_Type FT = new Frm_Type();
            FT.DataGridCell += new Action<string>(Id_DatagridCell);
            FT.ShowDialog();
        }

        private void Insert_Warehouse()
        {
            try
            {
                Warehouse_Bll.Insert_Warehouse(1, Convert.ToInt32(Txt_Type_Id.Text), Txt_Name.Text.Trim(), Txt_Phone.Text.Trim(), Txt_City.Text.Trim(), Convert.ToInt32(Txt_Area.Text), Txt_Ware_Desc.Text.Trim());
                Ok.ShowBox(" انبار با نام " + Txt_Name.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Name_Warehouse"))
                {
                    Warning.ShowBox("نام انبار تکراری و در فهرست موجود است .", "نام انبار !");
                    Txt_Type.Focus();
                }
            }
        }

        private void Btn_Warehouse_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Txt_Type_Id.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نوع انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Type_Id, 5000);
                TT.Show("شماره نوع انبار را وارد نمایید", Txt_Type_Id);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Name.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Name, 5000);
                TT.Show("نام انبار را وارد نمایید", Txt_Name);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Phone.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "تلفن !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Phone, 5000);
                TT.Show("تلفن را وارد نمایید", Txt_Phone);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Area.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "مساحت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Area, 5000);
                TT.Show("مساحت را وارد نمایید", Txt_Area);
            }
            else if (Txt_Type_Id.Text != "" && Txt_Name.Text != "" && Txt_Phone.Text != "" && Txt_Area.Text != "")
            {
                try
                {
                    Insert_Warehouse();
                    Combo();
                    Frm_Warehouse_Load(null, null);
                    Cmb_Job.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات انبار ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }
        #endregion

        #region Insert_Virtual
        private void Insert_Virtual_Ware()
        {
            try
            {
                Virtual_Bll.Insert_Virtual(Convert.ToInt32(Cmb_Job.SelectedValue), Txt_Vir_Name.Text.Trim(), Txt_Vir_Desc.Text.Trim());
                Ok.ShowBox(" قسمت با نام " + Txt_Vir_Name.Text + @"
ثبت شد .", "ثبت با موفقیت انجام شد !");
                tc.ClearTxt(this);
            }
            catch (SqlException ex)
            {
                if (ex.Message.Contains("IX_Name_Virtual"))
                {
                    Warning.ShowBox("نام قسمت تکراری و در فهرست موجود است .", "نام قسمت !");
                    Txt_Vir_Name.Focus();
                }
            }
        }

        private void Btn_Vir_Insert_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrWhiteSpace(Cmb_Job.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "شماره انبار !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Cmb_Job, 5000);
                TT.Show("شماره انبار را وارد نمایید", Cmb_Job);
            }
            else if (string.IsNullOrWhiteSpace(Txt_Vir_Name.Text))
            {
                ToolTip TT = new ToolTip();
                TT.Active = true;
                TT.ToolTipTitle = "نام قسمت !";
                TT.ToolTipIcon = ToolTipIcon.Warning;
                TT.Show(string.Empty, Txt_Vir_Name, 5000);
                TT.Show("نام قسمت را وارد نمایید", Txt_Vir_Name);
            }
            else if (Cmb_Job.Text != "" && Txt_Vir_Name.Text != "")
            {
                try
                {
                    Insert_Virtual_Ware();
                    Cmb_Job.ResetText();
                }
                catch
                {
                    Error.ShowBox(@"مشخصات قسمت ...
اتصال برنامه به دیتابیس را بررسی نمایید .", "مشخصات ذخیره نشد !");
                }
            }
        }

        private void Combo()
        {
            Cmb_Job.DataSource = new Warehouse_Bll().Ware_No_Combo();
            Cmb_Job.DisplayMember = "Name";
            Cmb_Job.ValueMember = "Id";
        }
        #endregion

        private void Frm_Warehouse_Load(object sender, EventArgs e)
        {
            Show_Warehouse();
            Combo();
            Cmb_Job.ResetText();
        }   
    }
}
