﻿using System;
using System.Windows.Forms;
using System.Threading;
using System.Drawing;

namespace RGF_Inventory_Bonakdar
{
    public partial class Wait : Form
    {
        private static Thread _LoadingScreenThread;
        private static Wait _ls;
        private static bool _shown = false;
        private static Form _parent;

        public Wait()
        {
            InitializeComponent();
        }

        public static void ShowLoadingScreen(Form parent)
        {
            _parent = parent;
            if (_LoadingScreenThread == null)
            {
                _LoadingScreenThread = new Thread(new ThreadStart(DoShowLoadingScreen));
                _LoadingScreenThread.SetApartmentState(ApartmentState.STA);
                _LoadingScreenThread.IsBackground = true;
                _LoadingScreenThread.Start();
            }
        }

        public static void CloseLoadingScreen()
        {
            System.Threading.Thread.Sleep(250);
            if (_ls != null && _ls.InvokeRequired)
            {
                _ls.Invoke(new MethodInvoker(CloseLoadingScreen));
            }
            else
            {
                if (_shown)
                {
                    _shown = false;
                    Application.ExitThread();
                }
                if (_LoadingScreenThread != null) _LoadingScreenThread.Interrupt();

                try
                {
                    _ls.Close();
                    _ls.Dispose();
                }
                catch
                {}
                _LoadingScreenThread = null;
            }
        }

        private static void DoShowLoadingScreen()
        {
            _ls = new Wait();
            _ls.Wait_Progress.IsRunning = true;
            _ls.ShowDialog();
        }

        private void Wait_Load(object sender, EventArgs e)
        {
            this.Activate();
        }
    }
}
